<?php
class PMW_Skins
{
	private static $_instance = NULL;
	
	public static function instance()
	{
		if (!self::$_instance)
		{
			self::$_instance = new self();
		}
		return self::$_instance;
	}
	
	private $_skin;
	private $_actionskins;
	private $_skinlibdirs;
	private $_skindir;
	private $_skindirurl;
	
	protected function __construct()
	{
		global $Skin, $ActionSkin, $SkinDir, $SkinDirUrl, $SkinLibDirs;
		
		$this->_skin = &$Skin;
		$this->_actionskins = &$ActionSkin;
		$this->_skindir = &$SkinDir;
		$this->_skindirurl = &$SkinDirUrl;
		$this->_skinlibdirs = &$SkinLibDirs;
	}
	
	public function set_action_skin($skin_name,$action_name = NULL)
	{
		if (is_null($action_name))
		{
			if (is_array($skin_name))
			{
				$actionskins = (array)$this->_actionskins;
				$this->_actionskins = array_merge($actionskins,$skin_name);
				if (array_key_exists('browse',$skin_name))
				{
					$this->_skin = $skin_name['browse'];
				}
			}
			else
			{
				$this->_skin = $skin_name;
			}
		}
		else
		{
			$this->_actionskins[$action_name] = $skin_name;
		}
	}
	// Accessor methods...
	public function get_skin()
	{
		return $this->_skin;
	}
	public function get_action_skins()
	{
		return $this->_actionskins;
	}
	public function get_skin_dirs()
	{
		$pmwiki = PMW_PmWiki::instance();
		$skindirs = array();
		$skinlibdirs = $this->_skinlibdirs;
		foreach($skinlibdirs as $dirfmt => $urlfmt) 
		{
			$SkinDir = $pmwiki->interpolate_with_pagename($dirfmt);
			if (is_dir($SkinDir)) 
			{
				$skindirs[] = realpath($SkinDir);
			}
		}
		return $skindirs;
	}
	public function get_skin_urls()
	{
		$pmwiki = PMW_PmWiki::instance();
		$skinurls = array();
		$skinlibdirs = $this->_skinlibdirs;
		foreach($skinlibdirs as $dirfmt => $urlfmt) 
		{
			$SkinDir = $pmwiki->interpolate_with_pagename($dirfmt);
			if (is_dir($SkinDir)) 
			{
				$SkinUrl = $pmwiki->interpolate_with_pagename($urlfmt);
				$skinurls[] = $SkinUrl;
			}
		}
		return $skinurls;
	}
	public function get_skin_dir()
	{
		return realpath($this->_skindir);
	}
	public function get_skin_url()
	{
		return $this->_skindirurl;
	}
	public function add_header_component($component, $index = NULL)
	{
		global $HTMLHeaderFmt;
		if (is_null($index))
		{
			$HTMLHeaderFmt[] = $component;
		}
		else
		{
			$HTMLHeaderFmt[$index] = $component;
		}
	}
}